// update bakup ************************************************************************************

function update_backup() {

	var get = document.getElementById('transfer');
	var transfer = get.options[get.selectedIndex].value;

	if (transfer == 'ftp') {
		document.getElementById('pass').setAttribute('type', 'password');
		document.getElementById('tr-server').style.display = '';
		document.getElementById('tr-path').style.display = '';
		document.getElementById('tr-user').style.display = '';
		document.getElementById('tr-password').style.display = '';
		document.getElementById('local').style.display = 'none';

		document.getElementById('frequency').tabindex = '6';
		document.getElementById('backup').tabindex = '7';
		document.getElementById('submit').tabindex = '8';
	}
	else if(transfer == 'local') {
		document.getElementById('pass').setAttribute('type', 'hidden');
		document.getElementById('tr-server').style.display = 'none';
		document.getElementById('tr-path').style.display = 'none';
		document.getElementById('tr-user').style.display = 'none';
		document.getElementById('tr-password').style.display = 'none';
		document.getElementById('local').style.display = '';

		document.getElementById('frequency').tabindex = '3';
		document.getElementById('backup').tabindex = '4';
		document.getElementById('submit').tabindex = '5';
	}
}

// used in menu in about.php ***********************************************************************

function select(object) {

	if(window.navigator.userAgent.indexOf('MSIE') != -1) {
		for(j = 0; j < object.parentNode.parentNode.childNodes.length; j++) {
			object.parentNode.parentNode.childNodes[j].childNodes[0].className = '';
		}
	}
	else {
		for(i = 1; i < object.parentNode.parentNode.childNodes.length; i+=2) {
			object.parentNode.parentNode.childNodes[i].childNodes[0].removeAttribute('class');
		}
	}

	object.className = 'selected';
}

// file input **************************************************************************************

function test() {
	var file_name = document.getElementById('upload_license').value;
	var valid = /.*\w\.xml$/;

	if(valid.test(file_name))
		document.getElementById('fake_input').value = file_name;
	else {
		document.getElementById('upload_license').value = '';
		document.getElementById('fake_input').value = '';
		alert('License file must have .xml extension');
	}
}

// add to & remove from selectlist *****************************************************************

function remove_selected (id) {
	var selectlist = document.getElementById(id);

	for (i = 0; i < selectlist.options.length; i++) {
		if (selectlist.options[i].selected == true) {
			selectlist.options[i] = null;
		}
	}
}

function add_selected(id,add_id) {
	var length = document.getElementById(id).options.length;
	var add = document.getElementById(add_id).value;

	if (is_ip_or_url(add)) {
		document.getElementById(id).options[length] = new Option(add,add);
		document.getElementById(add_id).value = '';
	}
	else
		alert('Please enter a valid IP address or ULR for you NTP server');
}

function select_all(id) {
	var selectlist = document.getElementById(id);

	for (i = 0; i < selectlist.options.length; i++) {
		document.getElementById(id).options[i].selected = 'selected';
	}
}

// validate sms ************************************************************************************

function validate_sms() {
	var msg = '';
	var pincode = document.getElementById('pin').value;

	if (pincode != '') {
		if(!is_numeric(pincode) || pincode.length != 4)
			msg += 'The PIN code must consist of 4 digits [0-9].'+"\n";
	}

	if (msg != '') {
		alert(msg);
		return false;
	}

	return true;
}

// validate email **********************************************************************************

function validate_email() {
	var msg = '';
	var host  	  = document.getElementById('host').value;
	var relay	  = document.getElementById('relay').value;
	var fallback  = document.getElementById('fallback').value;

	if (host != '') {
		if (!is_url(host))
			msg += 'Please enter a valid hostname.'+"\n";
	}
	if (relay != '') {
		if (!is_ip_or_url(relay))
			msg += 'Please enter a valid IP address or URL for your Relay host.'+"\n";
	}
	if (fallback != '') {
		if (!is_ip_or_url(fallback))
			msg += 'Please enter a valid IP address or URL for your Fallback relay.'+"\n";
	}

	if (msg != '') {
		alert(msg);
		return false;
	}

	return true;
}

// validate time ***********************************************************************************

function validate_ntp() {
	var msg = '';
	var avail = document.getElementById('avail').options.length;

	if (avail == 0)
		msg += 'You need to add at least one NTP server.'

	if (msg != '') {
		alert(msg);
		return false;
	}

	return true;
}

// validate network ********************************************************************************

function validate_network(step) {
	var msg = '';

	if (step == 1) {
		var hostname	= document.getElementById('host').value;
		var dns1  	 	= document.getElementById('dns1').value;
		var dns2   		= document.getElementById('dns2').value;
		var dns3   		= document.getElementById('dns3').value;

		if(!is_url(hostname))
			msg += 'Please enter a valid host name.'+"\n";
		if (!is_ip(dns1))
			msg += 'Please enter a valid IP address for your primary DNS.'+"\n";
		if (dns2 != '') {
			if (!is_ip(dns2))
				msg += 'Please enter a valid IP address for your secondary DNS.'+"\n";
		}
		if (dns3 != '') {
			if (!is_ip(dns3))
				msg += 'Please enter a valid IP address for your teritary DNS.'+"\n";
		}
	}
	else if(step == 2) {
		for (i = 0; i < (document.getElementsByTagName('input').length)-2; i++) {
			var check = document.getElementsByTagName('input')[i].value;
			if (document.getElementsByTagName('input')[i].type != "text")
				continue;
			if ((document.getElementsByTagName('input')[i].name.substring(0,2) != "eth")
			&& (document.getElementsByTagName('input')[i].name.substring(0,2) != "bon"))
				continue;
			if (!is_ip_or_url(check))
				msg += check+' is not a valid IP address or URL, please correct and try again.'+"\n";
		}

		var ok = confirm('WARNING: if you edited your network configuration, the network will be restarted and you will have '+
							'to navigate to your new host manually.'+"\n\n"+
							'Do not edit these settings unless you know exactly what you are doing.'+"\n\n"+
							'Are you sure you want to continue?');

		if (ok == false)
			return false;

	}
	if (msg != '') {
		alert(msg);
		return false;
	}

	return true;
}

// validate wizard *********************************************************************************

function validate_wizard(step) {
	var msg = '';
	if (step == 1) {
		if (document.getElementById('hostname') == true) {
			var hostname	= document.getElementById('hostname').value;
			var dns  	 	= document.getElementById('dns').value;
			var ipaddress  = document.getElementById('ip').value;
			var netmask	   = document.getElementById('netmask').value;
			var gateway    = document.getElementById('gateway').value;

			if(!is_url(hostname))
				msg += 'Please enter a valid host name.'+"\n";
			if (!is_ip(dns))
				msg += 'Please enter a valid IP address for your primary DNS.'+"\n";
			if (!is_ip(ipaddress))
				msg += 'Please enter a valid IP address.'+"\n";
			if (!is_ip(netmask))
				msg += 'Please enter a valid IP address for your netmask.'+"\n";
			if (!is_ip(gateway))
				msg += 'Please enter a valid IP address for your gateway.'+"\n";
		}
		var ok = confirm('WARNING: if you edited your network configuration, the network will be restarted and you will have '+
							'to navigate to your new host manually.'+"\n\n"+
							'Do not edit these settings unless you know exactly what you are doing.'+"\n\n"+
							'Are you sure you want to continue?');

		if (ok == false)
			return false;
	}
	else if (step == 2)
		return validate_time();
	else if (step == 3)
		return validate_email();
	else if (step == 4)
		return validate_sms();

	if (msg != '') {
		alert(msg);
		return false;
	}

	return true;
}

// update form according to dhcp *******************************************************************

function set_dhcp(name) {
	var yes = document.getElementById('dhcp_yes').checked;
	var no = document.getElementById('dhcp_no').checked;

	if (yes == true){
		if (name == 'wizard_start') {
			document.getElementById('manual').style.display = 'none';
			document.getElementById('hidden').value = 'save-dhcp';
		}
		else {
			document.getElementById('tr-host').style.display = 'none';
			document.getElementById('tr-dns1').style.display = 'none';
			document.getElementById('hidden').value = 'save-dhcp';
			if (name == 'wizard') {
				document.getElementById('tr-gateway').style.display = 'none';
				document.getElementById('tr-netmask').style.display = 'none';
				document.getElementById('tr-ip').style.display = 'none';
			}
			else {
				document.getElementById('step').style.display = 'none';
				document.getElementById('tr-dns2').style.display = 'none';
				document.getElementById('tr-dns3').style.display = 'none';
				document.getElementById('submit').className = 'button-save';
			}
		}
	}
	else {
		if (name == 'wizard_start') {
			document.getElementById('manual').style.display = '';
			document.getElementById('hidden').value = 'next-time';
		}
		else {
			document.getElementById('tr-host').style.display = '';
			document.getElementById('tr-dns1').style.display = '';

			if (name == 'wizard') {
				document.getElementById('tr-gateway').style.display = '';
				document.getElementById('tr-netmask').style.display = '';
				document.getElementById('tr-ip').style.display = '';
				document.getElementById('hidden').value = 'next-time';
			}
			else {
				document.getElementById('step').style.display = '';
				document.getElementById('tr-dns2').style.display = '';
				document.getElementById('tr-dns3').style.display = '';
				document.getElementById('submit').className = 'button-next';
				document.getElementById('hidden').value = 'next';
			}
		}
	}

	//alert(document.getElementById('hidden').value);
}

function set_dhcp_adv(eth) {
	var yes = document.getElementById(eth + '_dhcp_yes').checked;
	var no = document.getElementById(eth + '_dhcp_no').checked;

	if (yes == true){
		document.getElementById('tr1-' + eth).style.display = 'none';
		document.getElementById('tr2-' + eth).style.display = 'none';
		document.getElementById('tr3-' + eth).style.display = 'none';
	}
	else {
		document.getElementById('tr1-' + eth).style.display = '';
		document.getElementById('tr2-' + eth).style.display = '';
		document.getElementById('tr3-' + eth).style.display = '';
	}
}

// close wizard-window *****************************************************************************

function close_wizard() {
	document.getElementById('wizard').style.display = 'none';
	var check = document.getElementById('hide').checked;

	if (check == true) {
		create_cookie('op5 wizard','hide',999999);
	}
}

function wizard_display() {
	var kaka = read_cookie('op5 wizard');

	if (kaka == 'hide') {
		document.getElementById('wizard').style.display = 'none';
	}
}

// read & create cookie ****************************************************************************

function create_cookie(name,value,days) {
	if (days) {
		var date = new Date();
		date.setTime(date.getTime()+(days*24*60*60*1000));
		var expires = "; expires="+date.toGMTString();
	}
	else var expires = "";
	document.cookie = name+"="+value+expires+"; path=/";
}

function read_cookie(name) {
	var name_eq = name + '=';
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') {
			c = c.substring(1,c.length);
		}
		if (c.indexOf(name_eq) == 0)
			return c.substring(name_eq.length,c.length);
	}
	return null;
}

// add new interface *******************************************************************************

function add_iface(iface) {
	document.getElementById('new_iface').value = iface;
	document.getElementById('tr1-new').style.display = 'none';
	document.getElementById('tr2-new').style.display = '';
	document.getElementById('tr3-new').style.display = '';
}

// remove interface ********************************************************************************

function remove_iface(iface) {
	document.getElementById('remove_'+iface).value = iface;
	document.getElementById('trh-'+iface).style.display = 'none';
	document.getElementById('tr0-'+iface).style.display = 'none';
	document.getElementById('tr1-'+iface).style.display = 'none';
	document.getElementById('tr2-'+iface).style.display = 'none';
	document.getElementById('tr3-'+iface).style.display = 'none';
}

// services management *****************************************************************************

function svc_start(svc) {
	document.getElementById('service').value = svc;
	document.getElementById('action').value = 'start';
	document.getElementById('my_form').submit();
}

function svc_stop(svc) {
	document.getElementById('service').value = svc;
	document.getElementById('action').value = 'stop';
	document.getElementById('my_form').submit();
}

function svc_restart(svc) {
	document.getElementById('service').value = svc;
	document.getElementById('action').value = 'restart';
	document.getElementById('my_form').submit();
}
