<?php

require_once('productinfo.php');

class View {
	public $layout = 'template.php';
	public $title = 'ITRS OP5 Monitor Portal';
	public $sections = array('content' => null);

	private function section($name) {
		if(!isset($this->sections[$name]) || !$this->sections[$name]) {
			return null;
		}
		require $this->sections[$name];
	}

	private function menu() {
		$menu = array('/index.php' => 'Start');
		$web_conf = true;
		$settings_lib_path = "/opt/op5sys/lib/php/op5settings.php";
		if (file_exists($settings_lib_path) && is_readable($settings_lib_path)) {
			require_once($settings_lib_path);
			$web_conf = !(strtoupper(op5settings::inst()->webconfig) === "FALSE");
		}
		$rpmstatus = 1;
		@system('rpm -q op5config --quiet', $rpmstatus);
		if ($rpmstatus == 0 && $web_conf ) {
			$menu['/op5config'] = 'Configure System';
		}
		$menu += array(
			'/about.php' => 'About',
			'http://www.op5.com/support/' => 'Support',
			'http://www.op5.com' => 'op5.com'
		);

		$itemize = function($href, $title) {
			$current = null;
			if(substr($_SERVER['PHP_SELF'], -strlen($href)) == $href) {
				$current = ' class=selected ';
			}
			$target = null;
			if(strpos($href, 'http') !== false) {
				$target = ' target=_blank ';
			}
			return "<li><a href='$href' $current $target>$title</a></li>";
		};

		$as_string = null;
		foreach($menu as $href => $title) {
			$as_string .= $itemize($href, $title);
		}
		return '<ul>'.$as_string.'</ul>';
	}

	function product_version($product = 'unused') {
		$versionfile = '/etc/op5-monitor-release';
		return productinfo::product_version($versionfile);
	}

	function render() {
		require( $this->layout );
	}
}
